qtrvsim (0.9.8-1) unstable; urgency=medium

  * Machine: aclintmtimer fix count type
  * GUI: fix a crash on nonexistent include
  * Use win32 config of libelf when compiling natively for Windows
  * CI: Add Windows Clang debug build and macos ARM
  * CLI: reporter dump to json
  * Machine: instruction parsing refactor
  * GUI: make printer settings persistent and scale to fit PDF page size
  * Assembler: fix immediate parsing
  * Assembler: implement GAS modifiers - PC rel still basic only
  * Machine: fix zext.w/h inst parse and fix tokenized for inst.xxx
  * Machine: fix parse_csr_address and CSR::RegisterMapByName key type
  * Machine and GUI: Pseudo LRU cache policy
  * Add 25x speed for teaching convenience
  * Machien and GUI: Include Jiri Stefan's work on branch predictor
  * Machien and GUI: BTB, BHT and BHR are implemented
  * Project: Explicit cmake qt major version option
  * Packaging: add Keywords entry into desktop file
  * Machine: add peripherals high/top address aliases for XLEN=64
  * GUI: switch "New" dialog page selection to tree widget, polishing required

-- Pavel Pisa <pisa@cmp.felk.cvut.cz>  Tue, 01 Oct 2024 20:45:22 +0200

qtrvsim (0.9.7-1) unstable; urgency=medium

  * GUI: fix examples button crashes on Windows and sometimes other platforms
  * GUI: fix crash when no tab is selected
  * CI: add windows libs to artifacts and use more cores available
  * CI: Make pack QT with Win artifact
  * Project: Use the include directory for LibElf on macOS, Homebrew misses RISC-V
  * Machine: set SXL and UXL to 64-bit XLEN for RV64

-- Pavel Pisa <pisa@cmp.felk.cvut.cz>  Thu, 15 Feb 2024 20:57:12 +0100

qtrvsim (0.9.6-1) unstable; urgency=medium

  * GUI: add reset widows menu entry to restore default windows layout
  * Machine: extend CSR support to pass rv32mi-p-mcsr and rv64mi-p-mcsr official test
  * Machine: serial port interrupts reworked for RISC-V as platform irq 16 and 17
  * GUI: RISC-V ACLINT MTIMER mapping added into resources/samples/template.S
  * Machine: implemented RISC-V A extension for RV32IMA/RV64IMA support
  * GUI: the XLEN, atomic and multiply options available in new simulation dialog
  * GUI: update registers and CSR views for bare RV64IMA support
  * Machine and GUI: simple level 2 cache implementation
  * GUI: increase cache set count limit to 1024
  * CLI: add isa-variant, cycle-limit and l2-cache options
  * CLI: dump-ranges allows to use symbols even from internal assembly
  * Memory: correctly propagate external/DMA changes to GUI
  * Machine: where possible, re-implement pseudo instructions by aliase tables
  * os_emulation: resolve problem with write and read from/to stack area on RV32
  * GUI: fix double free of children widgets in control register widget
  * GUI: refactor gui source file to tree structure
  * GUI: program view - collapse address and breakpoint if space is limited
  * GUI: split central widget tabs to coreview and editor
  * GUI: editor line numbers and highlight error in the editor on message click
  * GUI: editor toggle comment (ctrl+/)
  * GUI: ensure that all lines of external make process output are processed
  * os_emulation: correct ftruncate syscall arguments for 64 and 32-bit ABI
  * Update README.md to document interrupt, trap, ACLINT+MTIMER and AMO support
  * CI: drop support for Ubuntu 18
  * Project: bump to c++17

-- Pavel Pisa <pisa@cmp.felk.cvut.cz>  Mon, 11 Dec 2023 11:12:15 +0100

qtrvsim (0.9.5-1) unstable; urgency=medium

  * Machine: use cvector in instruction args to spedup decoding
  * Machine: move controlstate to csr and prepare BitArg to be usd there
  * Machine: use method for CSR writes to enable mutual register dependencies
  * Machine: CSR: define mie register.
  * Machine: CSR: fix conditions for register write and add mie to the list.
  * Machine: fix range for branch instructions B-encoding
  * CLI: add simple tracer for memory reads and writes.
  * CLI: initial support to enable OS emulation even for CLI version
  * GUI: update coreview graphics by Michal Stepanosvky
  * GUI: fix wrong svg label connection and reset all to zero

 -- Pavel Pisa <pisa@cmp.felk.cvut.cz>  Mon, 16 Jan 2023 11:22:08 +0200

qtrvsim (0.9.4-1) unstable; urgency=medium

  * GUI: Async modal library to overcome WebAssembly/Emscripten limitations
  * Wasm: support and build improved
  * os_emulation: correct open flags O_xxx values to match RISC-V Linux ABI.
  * packaging: fix Fedora build according to Jan Grulich advice.
  * README.md: add reference to Embedded World Conference 2022 article.
  * qtrvsim_tester: Tomas Veznik implemented testing against official RISC/V ISA tests.
  * CI: speedup by using common build of official tests
  * Machine: initial support for CSR instructions by Jakub Dupak
  * GUI: CSR: syntax highlight CSR reg names
  * Machine: CSR: disassemble CSR register based on the mnemonic register settings
  * GUI: save mnemonic registers settings
  * Machine: add support for 64-bit RV64IM target and related 32-bit/word limited instructions
  * README.md: update information about basic 64-bit support.

 -- Pavel Pisa <pisa@cmp.felk.cvut.cz>  Mon, 24 Oct 2022 23:07:19 +0200

qtrvsim (0.9.3-1) unstable; urgency=medium

  * Debian package updated to version 0.9.3.
  * Machine: fix LCD display endianness.
  * Machine: correct memory stall cycles computation.
  * Machine: correct unaligned and partial (lb, sb, lh, sh) to peripheral registers.
  * Packaging: flatpak support kindly provided by David Heidelberg <david@ixit.cz>
  * Machine and GUI: switch to RISC-V CSR names and remove references to MIPS COP0.
  * Machine: correct parsing of registers s10 and s11 names.
  * Machine: fix null pointer usage in cache
  * GUI: fix null pointer usage in cache
  * Machine: correct cache graphics visualization for byte accesses.
  * Machine: LFU cache policy incorrect use of sets count instead of degree of associativity.

 -- Pavel Pisa <pisa@cmp.felk.cvut.cz>  Thu, 21 Apr 2022 09:40:37 +0200

qtrvsim (0.9.2-1) unstable; urgency=medium

  * Debian package updated to version 0.9.2.
  * GUI: rework of coreview graphics to correspond to Mr. Stepanovsky slides
  * CI: downgrade runner os to win2019 to prevent failing builds
  * WASM: fix exception support
  * LRU cache policy fix (check was incoorect only for flush, i.e. fence instruction)
  * Machine: basic RV32M support (no specific GUI provided, considered as part of ALU)
  * README.md update, document RV32M support
  * Machine: RISC-V ABI places stack pointer into x2 register.
  * Machine: rewrite all core_alu_forward and complex memory tests for RISC-V.
  * Machine: RISC-V is by default little endian, even when ELF file is not loaded

 -- Pavel Pisa <pisa@cmp.felk.cvut.cz>  Tue, 12 Mar 2022 20:45:12 +0200

qtrvsim (0.9.1-1) unstable; urgency=medium

  * Debian package updated to version 0.9.1.
  * Recognize FENCE and FENCE.I instructions, they flush whole cache for now.
  * Corrected register numbers visualization.
  * Corrected negative numbers in disassembler.
  * Bugfixes and cleanup.

 -- Pavel Pisa <pisa@cmp.felk.cvut.cz>  Tue, 1 Mar 2022 19:15:22 +0200

qtrvsim (0.9.0-1) unstable; urgency=medium

  * Debian package updated to version 0.9.0.
  * JALR.
  * Basic pseudoinstruction support.
  * Partial recreation of testing.
  * Bugfixes and cleanup.

 -- Jakub Dupak <dev@jakubdupak.com>  Tue, 15 Feb 2022 03:32:50 +0200

qtrvsim (0.8.1-1) unstable; urgency=medium

  * Debian package updated to version 0.8.1-1.
  * Fixes visualization of stalls.
  * Moves jump evaluation from EX to MEM as initially intended and as shown in the cpu diagram.
  * Fixes WASM build - keyboard handling.
  * Adds Qt6 support.

 -- Jakub Dupak <dev@jakubdupak.com>  Wed, 15 Dec 2021 18:55:55 +0100

qtrvsim (0.8.0) unstable; urgency=medium

  * Debian package updated to version 0.8.0.

 -- Jakub Dupak <dev@jakubdupak.com>  Mon, 17 May 2021 15:27:10 +0200

qtrvsim (0.8.0-1) unstable; urgency=medium

  * Debian package updated to version 0.8.0.
  * Switch to RISC-V simulator
 -- Jakub Dupak <dev@jakubdupak.com>  Tue, 04 May 2021 23:01:01 +0200

qtmips (0.7.5) unstable; urgency=medium

  * Debian package updated to version 0.7.5.
  * Improve UI compatbility with dark color schemes (by Michal Maly, MadCatX)
  * prepare-release: document alternative Debian package preparation in quilt mode.
  * Enable dock widows nesting to enable show cache + memory simultaneously (by Frantisek Vacek)
  * AppImage build run (by Frantisek Vacek)
  * qtmips_cli: add option to connect serial port input and output to file.
  * samples: template-os.S template.S fixed SPILED_REG_BASE definition.
  * README: add documentation how to modify comprocessor 0 regs (by Jan Kaisrlik)
  * EADME.md: fix reference to uart rx interrupt mask (by Jan Kaisrlik)
  * Fix open of ELF files using national alphabets in the path names on Windows.
  * qtmips_gui: fix response to user decision to save modified file when make is invoked.

 -- Pavel Pisa <pisa@cmp.felk.cvut.cz>  Sun, 06 Sep 2020 13:16:34 +0200

qtmips (0.7.4) unstable; urgency=medium

  * Debian package updated to version 0.7.4.
  * debian packaging: add git attribute to merge changelog.
  * debian packaging: add watch file for GitHub QtMips repository.

 -- Pavel Pisa <pisa@cmp.felk.cvut.cz>  Sun, 15 Sep 2019 20:32:41 +0200

qtmips (0.7.3) unstable; urgency=medium

  * Debian package updated to version 0.7.3.
  * Implemented SKIP/SPACE assembler directives.
  * Add OpenHub statistic page link.
  * Provide support for include directive in simple assembler.
  * In include, use content from editor if file is already open.
  * Add #pragma processing to integrated assembler and its usage to control windows.
  * Use #pragma in examples to lower initial learning curve.
  * samples: simple-lw-sw-ia.S: place data section to 0x2000 address.
 
 -- Pavel Pisa <pisa@cmp.felk.cvut.cz>  Thu, 12 Sep 2019 11:47:46 +0200

qtmips (0.7.2) unstable; urgency=medium

  * Debian package updated to version 0.7.2.
  * More changes to use dialog open instead of exec (Emscripten does not support exec).
  * Updates to RPM packaging and spec file to better follow Suse rules.
  * Move fixmatheval and assembly compiler to separate library independent on Qt GUI API.
  * Implemented message window to report compilation errors.
  * Store operator text description in the fixmatheval operators tree.
  * Simple assembler moved to separate class which is independent on Qt GUI API.
  * Do not open editor twice for same filename.
  * Enable CLI version to use simple assembler.
  * Update editor search algorithm to prefer current editor for unnamed buffers.
  * Add config option to reset machine before internal assembler starts.
  * Include C language syntax highlighter for alternative sources editing.
  * Action to execute external make command and ask for unsaved sources.
  * Ask to save modified files on exit.
  * Ask for modified source close and handle unnamed sources close.
  * Replace shortcuts to not hide Ctrl+C and some others.
  * Implemented ASCII and ASCIZ operations.
  * Include actions New source and Close source on toolbar.
  * Make program and memory window visible when address requested from symbol dialog.
  * Add embedded examples menu and resources.

 -- Pavel Pisa <pisa@cmp.felk.cvut.cz>  Wed, 21 Aug 2019 00:13:06 +0200

qtmips (0.7.1) unstable; urgency=medium

  * Debian package updated to version 0.7.1.
  * Add option to parse and show symbolic registers names.
  * Implemented simple integrated assembler - it is not recommended for advanced users.
  * Updated instructions parsing to be usable for integrated assembler.
  * Change instruction parsing to allow multiple words pseudo-operations.
  * Implemented simple expressions and labels/symbols evaluation.
  * Simple highlighter for assembly language added.
  * Include simple text editor in QtMips emulator.
  * Fix memory leakages which repeat during program operation.
  * Externally caused address-space changes (i.e. from peripherals) update memory view.
  * Provide option to hide coreview to speedup simulation.

 -- Pavel Pisa <pisa@cmp.felk.cvut.cz>  Wed, 03 Jul 2019 12:18:15 +0200

qtmips (0.7.0) unstable; urgency=medium

  * Debian package updated to version 0.7.0.
  * Include simple LCD frame-buffer and display implementation.
  * Simulate push of dial buttons by check box.
  * Allow to create simulator without loaded executable.
  * Printing/export to PDF file reduces print area/page to actual image size.
  * Disable text elide for memory and program views (fix for MAC OS).
  * Implement standard zoom handling by mouse wheel and keys.

 -- Pavel Pisa <pisa@cmp.felk.cvut.cz>  Fri, 28 Jun 2019 15:38:52 +0200

qtmips (0.6.8) unstable; urgency=medium

  * Debian package updated to version 0.6.8.
  * Coreview multiplexers updated and added for branch compare forward.
  * qtmips_gui: set application window icon.
  * Set gray background to stalled instructions/idled stages.
  * Setting background color dial
  * qtmips_cli: start report in decimal mode.

 -- Pavel Pisa <pisa@cmp.felk.cvut.cz>  Mon, 01 Apr 2019 15:26:46 +0200

qtmips (0.6.7) unstable; urgency=medium

  * Debian package updated to version 0.6.7.
  * Change single cycle core with delay slot to use separate fetch stage.
  * Program listing and stages use color background.
  * Correct write through spelling. Reported by Richard Susta.
  * qtmips_cli can be used for cache statistic and result memory tests.

 -- Pavel Pisa <pisa@cmp.felk.cvut.cz>  Wed, 27 Mar 2019 00:38:24 +0100

qtmips (0.6.6) unstable; urgency=medium

  * Corrected row and column output in cache address fields.
  * Highlight cache read and write acesses.
  * Highlight registers and coprocessor 0 read and writes.

 -- Pavel Pisa <pisa@cmp.felk.cvut.cz>  Sun, 17 Mar 2019 20:51:55 +0100

qtmips (0.6.5) unstable; urgency=medium

  * Initial Debian packaging.

 -- Pavel Pisa <pisa@cmp.felk.cvut.cz>  Wed, 13 Mar 2019 19:38:33 +0100
